#
#	Copyright (C) 2007, 2008, 2009. PARP Research Group.
#	<http://perception.inf.um.es>
#	University of Murcia, Spain.
#
#	This file is part of the QVision library.
#
#	QVision is free software: you can redistribute it and/or modify
#	it under the terms of the GNU Lesser General Public License as
#	published by the Free Software Foundation, version 3 of the License.
#
#	QVision is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU Lesser General Public License for more details.
#
#	You should have received a copy of the GNU Lesser General Public
#	License along with QVision. If not, see <http://www.gnu.org/licenses/>.
#

#############################
#
#	File src.pro
#

################################
## GENERAL CONFIG
TEMPLATE = lib
TARGET = qvision
DESTDIR = ../lib
VERSION = 0.2.1

DEPENDPATH += .
INCLUDEPATH += . include/

RCC_DIR = ../build/rcc
MOC_DIR = ../build/moc
UI_DIR = ./ui
OBJECTS_DIR = ../build/obj

win32 : CONFIG += console		# Si se quiere imprimir por pantalla en Windows
QT += opengl xml

# caso de linux (por ahora), definimos extensiones OpenGL para YUV acelerado.
# unix:DEFINES += LINUX_GL_YUV_ACCEL

################################
## PACKAGES INFORMATION
include(../qvision.pri)

################################
## DEPENDING PACKAGES FILES
# qvCore
HEADERS +=	qvdefines.h
SOURCES +=	qvdefines.cpp

# qvUtils
HEADERS +=	qvutils/qnamedpipe.h			\
		qvutils/qvcpustat.h			\
		qvutils/qvcpustatcontroler.h		\
		qvutils/qvsleeper.h			\
		qvutils/qtree.h				\
		qvutils/qvindexedstringlist.h

SOURCES +=	qvutils/qnamedpipe.cpp			\
		qvutils/qvcpustat.cpp			\
		qvutils/qvcpustatcontroler.cpp		\
		qvutils/qvsleeper.cpp			\
		qvutils/qvindexedstringlist.cpp

# qvIO
HEADERS +=	qvio/qvio.h							\
		qvblockprogramming/qvioblocks/qvvideoreaderblock.h		\
		qvblockprogramming/qvioblocks/qvyuv4mpeg2readerblock.h		\
		qvblockprogramming/qvioblocks/qvyuv4mpeg2writerblock.h

SOURCES +=	qvio/qvio.cpp							\
		qvblockprogramming/qvioblocks/qvvideoreaderblock.cpp		\
		qvblockprogramming/qvioblocks/qvyuv4mpeg2readerblock.cpp	\
		qvblockprogramming/qvioblocks/qvyuv4mpeg2writerblock.cpp

# Forms
RESOURCES = ./resources/qvision.qrc

FORMS +=	ui/qvprocessingblockformsmall.ui	\
		ui/qvvideoreaderblockwidget.ui		\
		ui/qvvideoreaderblockwidgetsmall.ui

# qvIP
HEADERS +=	qvip/qvip.h		\
		qvip/qvimagebuffer.h	\
		qvip/qvgenericimage.h	\
		qvip/qvimage.h		\
		qvip/qvpolyline.h	\
		qvip/qvpolylinef.h	\
		qvip/qvcomponenttree.h	\
		qvip/qvmser.h

SOURCES +=	qvip/qvip.cpp			\
		qvip/qvimagebuffer.cpp		\
		qvip/qvgenericimage.cpp		\
		qvip/qvimage.cpp		\
		qvip/qvpolyline.cpp		\
		qvip/qvpolylinef.cpp		\
		qvip/qvcomponenttree.cpp	\
		qvip/qvmser.cpp

# qvIPP
HEADERS +=	qvip/qvipp/qvipp.h

SOURCES +=	qvip/qvipp/qvipp.cpp		\
		qvip/qvipp/qvippfunctions.cpp

# qvMath
SOURCES +=	qvmath/qvmath.cpp			\
		qvmath/qvtensorindex.cpp		\
		qvmath/qvtensorindexator.cpp		\
		qvmath/qvtensor.cpp			\
		qvmath/qvmatrixalgebra.cpp		\
		qvmath/qvmatrix.cpp			\
		qvmath/qvvector.cpp			\
		qvmath/qvfunction.cpp			\
		qvmath/qvquaternion.cpp			\
		qvmath/qvrationalnumber.cpp		\
		qvmath/qvdisjointset.cpp		\
		qvmath/qvcombinationiterator.cpp	\
		qvmath/qvprojective.cpp			\
		qvmath/qvnumericalanalysis.cpp		\
		qvmath/qvsampleconsensus.cpp		\
		qvmath/qvstatistics.cpp			\
		qvmath/qv2dmap.cpp

HEADERS +=	qvmath/qvmath.h				\
		qvmath/qvblasdatabuffer.h		\
		qvmath/qvtensorindex.h			\
		qvmath/qvtensorindexator.h		\
		qvmath/qvtensor.h			\
		qvmath/qvmatrixalgebra.h		\
		qvmath/qvvector.h			\
		qvmath/qvfunction.h			\
		qvmath/qvquaternion.h			\
		qvmath/qvrationalnumber.h		\
		qvmath/qvdisjointset.h			\
		qvmath/qvcombinationiterator.h		\
		qvmath/qvprojective.h			\
		qvmath/qvnumericalanalysis.h		\
		qvmath/qvsampleconsensus.h		\
		qvmath/qvstatistics.h			\
		qvmath/qv2dmap.h


#################### Block programming #########################
# Main classes
HEADERS +=	qvblockprogramming/qvapplication.h			\
		qvblockprogramming/qvprocessingblock.h			\
		qvblockprogramming/qvpropertycontainer.h		\
		qvblockprogramming/qvpropertycontainerchange.h

SOURCES +=	qvblockprogramming/qvapplication.cpp			\
		qvblockprogramming/qvprocessingblock.cpp		\
		qvblockprogramming/qvpropertycontainer.cpp		\
		qvblockprogramming/qvpropertycontainerchange.cpp
# blocks
SOURCES +=	qvblockprogramming/qvprocessingblocks/qvimageresizerblock.cpp		\
		qvblockprogramming/qvprocessingblocks/qvimageretarderblock.cpp		\
		qvblockprogramming/qvprocessingblocks/qvplanarrectifierblock.cpp	\
		qvblockprogramming/qvprocessingblocks/qvharrispointdetector.cpp		\
		qvblockprogramming/qvprocessingblocks/qvcannyedgedetector.cpp		\
		qvblockprogramming/qvprocessingblocks/qvmserdetector.cpp		\
		qvblockprogramming/qvprocessingblocks/qvhessianpointdetector.cpp	\
		qvblockprogramming/qvprocessingblocks/qvimagemeansblock.cpp		\
		qvblockprogramming/qvprocessingblocks/qvsynchronizerblock.cpp		\
		qvblockprogramming/qvprocessingblocks/qvpointblock.cpp			\
		qvblockprogramming/qvprocessingblocks/qvippblocks.cpp

HEADERS +=	qvblockprogramming/qvprocessingblocks/qvimageresizerblock.h		\
		qvblockprogramming/qvprocessingblocks/qvimageretarderblock.h		\
		qvblockprogramming/qvprocessingblocks/qvplanarrectifierblock.h		\
		qvblockprogramming/qvprocessingblocks/qvharrispointdetector.h		\
		qvblockprogramming/qvprocessingblocks/qvcannyedgedetector.h		\
		qvblockprogramming/qvprocessingblocks/qvmserdetector.h			\
		qvblockprogramming/qvprocessingblocks/qvhessianpointdetector.h		\
		qvblockprogramming/qvprocessingblocks/qvimagemeansblock.h		\
		qvblockprogramming/qvprocessingblocks/qvsynchronizerblock.h		\
		qvblockprogramming/qvprocessingblocks/qvpointblock.h			\
		qvblockprogramming/qvprocessingblocks/qvippblocks.h

# GUI
HEADERS +=	qvblockprogramming/qvguiblocks/qvparamwidget.h				\
		qvblockprogramming/qvguiblocks/qvvideoreaderblockwidget.h		\
		qvblockprogramming/qvguiblocks/qvvideoreaderblockwidgetsmall.h		\
		qvblockprogramming/qvguiblocks/qvparamsinspectorwidget.h		\
		qvblockprogramming/qvguiblocks/qvblockinterfacesmall.h			\
		qvblockprogramming/qvguiblocks/qvcanvas.h				\
		qvblockprogramming/qvguiblocks/qvimagecanvas.h				\
		qvblockprogramming/qvguiblocks/qvgui.h					\
		qvblockprogramming/qvguiblocks/qvdefaultgui.h				\
		qvblockprogramming/qvguiblocks/qvisioninterface.h			\
		qvblockprogramming/qvguiblocks/qv3dcanvas.h				\
		qvblockprogramming/qvguiblocks/qv3dmodel.h

SOURCES +=	qvblockprogramming/qvguiblocks/qvvideoreaderblockwidget.cpp		\
		qvblockprogramming/qvguiblocks/qvvideoreaderblockwidgetsmall.cpp	\
		qvblockprogramming/qvguiblocks/qvcanvas.cpp				\
		qvblockprogramming/qvguiblocks/qvimagecanvas.cpp			\
		qvblockprogramming/qvguiblocks/qvgui.cpp				\
		qvblockprogramming/qvguiblocks/qvdefaultgui.cpp				\
		qvblockprogramming/qvguiblocks/qvparamsinspectorwidget.cpp		\
		qvblockprogramming/qvguiblocks/qvparamwidget.cpp			\
		qvblockprogramming/qvguiblocks/qvblockinterfacesmall.cpp		\
		qvblockprogramming/qvguiblocks/qvisioninterface.cpp			\
		qvblockprogramming/qvguiblocks/qv3dcanvas.cpp				\
		qvblockprogramming/qvguiblocks/qv3dmodel.cpp

# qvQWT
HEADERS +=	qvblockprogramming/qvguiblocks/qvplot.h			\
		qvblockprogramming/qvguiblocks/qvcpuplot.h		\
		qvblockprogramming/qvguiblocks/qvnumericplot.h		\
		qvblockprogramming/qvguiblocks/qvhistogramplot.h	\
		qvblockprogramming/qvguiblocks/qvfunctionplot.h	\
		qvblockprogramming/qvguiblocks/qvhistogram.h

SOURCES +=	qvblockprogramming/qvguiblocks/qvplot.cpp		\
		qvblockprogramming/qvguiblocks/qvcpuplot.cpp		\
		qvblockprogramming/qvguiblocks/qvnumericplot.cpp	\
		qvblockprogramming/qvguiblocks/qvhistogramplot.cpp	\
		qvblockprogramming/qvguiblocks/qvfunctionplot.cpp	\
		qvblockprogramming/qvguiblocks/qvhistogram.cpp

# Designer
RESOURCES +=	qvblockprogramming/qvguiblocks/qvdesigner/resources/resources.qrc

HEADERS +=	qvblockprogramming/qvguiblocks/qvdesigner/slate/link.h			\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/asinclink.h		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/sinclink.h		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/grouplink.h		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/sequenlink.h		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/node.h			\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/groupnode.h		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/middlenode.h		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/inputnode.h		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/outputnode.h		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/slateview.h		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/insertaction.h		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/informer.h		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/slatewindow.h		\
		qvblockprogramming/qvguiblocks/qvdesigner/qvdesignergui.h		\
		qvblockprogramming/qvguiblocks/qvdesigner/facade/itemproperties.h	\
		qvblockprogramming/qvguiblocks/qvdesigner/facade/itemfactory.h		\
		qvblockprogramming/qvguiblocks/qvdesigner/facade/blockdialog.h		\
		qvblockprogramming/qvguiblocks/qvdesigner/facade/imagecanvasdialog.h	\
		qvblockprogramming/qvguiblocks/qvdesigner/facade/camerablockdialog.h

SOURCES += qvblockprogramming/qvguiblocks/qvdesigner/slate/link.cpp			\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/asinclink.cpp		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/sinclink.cpp		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/grouplink.cpp		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/sequenlink.cpp		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/node.cpp		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/groupnode.cpp		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/middlenode.cpp		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/inputnode.cpp		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/outputnode.cpp		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/slateview.cpp		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/insertaction.cpp	\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/informer.cpp		\
		qvblockprogramming/qvguiblocks/qvdesigner/slate/slatewindow.cpp		\
		qvblockprogramming/qvguiblocks/qvdesigner/qvdesignergui.cpp		\
		qvblockprogramming/qvguiblocks/qvdesigner/facade/itemproperties.cpp	\
		qvblockprogramming/qvguiblocks/qvdesigner/facade/itemfactory.cpp	\
		qvblockprogramming/qvguiblocks/qvdesigner/facade/blockdialog.cpp	\
		qvblockprogramming/qvguiblocks/qvdesigner/facade/imagecanvasdialog.cpp	\
		qvblockprogramming/qvguiblocks/qvdesigner/facade/camerablockdialog.cpp

####################################################
# CUDA module
qvcuda	{
	SOURCES +=	qvcuda/qvcudaip.cpp			\
			qvcuda/qvcudautils.cpp

	HEADERS +=	qvcuda/qvcudaip.h			\
			qvcuda/qvcudautils.h			\
			qvcuda/qvcudaimage.h			\
			qvcuda/qvcudaipD.h

	CUDA_SOURCES +=	qvcuda/qvcudaipD.cu

	#install_include_qvcuda.path = $$INSTALL_PATH/include/qvcuda
	#install_include_qvcuda.files = qvcuda/*.h
	#INSTALLS += install_include_qvcuda
	}

####################################################
# MPlayer compatibility
qvmplayercamera	{
		HEADERS +=	qvio/qvmplayerreader.h					\
				qvblockprogramming/qvioblocks/qvmplayerreaderblock.h

		SOURCES +=	qvio/qvmplayerreader.cpp				\
				qvblockprogramming/qvioblocks/qvmplayerreaderblock.cpp
		}

######################################################################
# Installation

# General files
install_base.path = $$INSTALL_PATH
install_base.files = ../*.pri ../README ../COPYING ../COPYING.LESSER

install_lib.path = $$INSTALL_PATH
install_lib.files = ../lib

install_doc.path = $$INSTALL_PATH/doc
install_doc.files = ../doc/html/*

install_include_ui.path = $$INSTALL_PATH/include/
install_include_ui.files = ui

install_include_resources.path = $$INSTALL_PATH/include
install_include_resources.files = resources

# Install header files
install_include.path =	$$INSTALL_PATH/include/
install_include.files =	QV* $$HEADERS

# Install directives
INSTALLS = 	install_base				\
		install_lib				\
		install_doc				\
		install_include_ui			\
		install_include_resources		\
		install_include

